﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using AIOUSBNet;  // the namespace exposes the AIOUSB Class interface 

// You must also add a reference to the AIOUSBnet.dll in the project settings


namespace Sample1
{
    public partial class Form1 : Form
    {
        // One and only Device Index:
        public UInt32 DeviceIndex;
        public UInt32 numPins = 72;
        public UInt32 numPorts = 9;

        // Interval Timer fou GUI update:
        // (Note: A Windows Forms timer designed for single threaded environments not a System Timer 55 ms min res)
        static System.Windows.Forms.Timer myTimer = new System.Windows.Forms.Timer();

        // Array of controls for GUI updates:
        public CheckBox[] checkStateArray = new CheckBox[72];
        public Button[] toggleBtnArray = new Button[9];

        // For bitmasks:
        byte[] OutMask = new byte[] { 0, 0 };
        byte[] Data = new byte[] { 0, 0, 0, 0, 0, 0, 0, 0, 0,};  // 9 

        // State flags:
        byte bTristateAll = 0;  // 0 = false all bits not tristated
        public bool[] bModeOut = new bool[9];
        
        public Form1()
        {
            InitializeComponent();
            int i = 0;

            // Array of the toggle mode buttons:
            toggleBtnArray[0] = btnToggle3;
            toggleBtnArray[1] = btnToggle4;
            toggleBtnArray[2] = btnToggle5;
            toggleBtnArray[3] = btnToggle6;
            toggleBtnArray[4] = btnToggle7;
            toggleBtnArray[5] = btnToggle8;
            toggleBtnArray[6] = btnToggle0;
            toggleBtnArray[7] = btnToggle1;
            toggleBtnArray[8] = btnToggle2;


            // Array of the LED style checkboxes:
            
            checkStateArray[0] = checkBox_0;
            checkStateArray[1] = checkBox_1;
            checkStateArray[2] = checkBox_2;
            checkStateArray[3] = checkBox_3;
            checkStateArray[4] = checkBox_4;
            checkStateArray[5] = checkBox_5;
            checkStateArray[6] = checkBox_6;
            checkStateArray[7] = checkBox_7;
            checkStateArray[8] = checkBox_8;
            checkStateArray[9] = checkBox_9;
            checkStateArray[10] = checkBox_10;
            checkStateArray[11] = checkBox_11;
            checkStateArray[12] = checkBox_12;
            checkStateArray[13] = checkBox_13;
            checkStateArray[14] = checkBox_14;
            checkStateArray[15] = checkBox_15;
            checkStateArray[16] = checkBox_16;
            checkStateArray[17] = checkBox_17;
            checkStateArray[18] = checkBox_18;
            checkStateArray[19] = checkBox_19;
            checkStateArray[20] = checkBox_20;
            checkStateArray[21] = checkBox_21;
            checkStateArray[22] = checkBox_22;
            checkStateArray[23] = checkBox_23;

            checkStateArray[24] = checkBox_24;
            checkStateArray[25] = checkBox_25;
            checkStateArray[26] = checkBox_26;
            checkStateArray[27] = checkBox_27;
            checkStateArray[28] = checkBox_28;
            checkStateArray[29] = checkBox_29;
            checkStateArray[30] = checkBox_30;
            checkStateArray[31] = checkBox_31;
            checkStateArray[32] = checkBox_32;
            checkStateArray[33] = checkBox_33;
            checkStateArray[34] = checkBox_34;
            checkStateArray[35] = checkBox_35;
            checkStateArray[36] = checkBox_36;
            checkStateArray[37] = checkBox_37;
            checkStateArray[38] = checkBox_38;
            checkStateArray[39] = checkBox_39;
            checkStateArray[40] = checkBox_40;
            checkStateArray[41] = checkBox_41;
            checkStateArray[42] = checkBox_42;
            checkStateArray[43] = checkBox_43;
            checkStateArray[44] = checkBox_44;
            checkStateArray[45] = checkBox_45;
            checkStateArray[46] = checkBox_46;
            checkStateArray[47] = checkBox_47;

            checkStateArray[48] = checkBox_48;
            checkStateArray[49] = checkBox_49;
            checkStateArray[50] = checkBox_50;
            checkStateArray[51] = checkBox_51;
            checkStateArray[52] = checkBox_52;
            checkStateArray[53] = checkBox_53;
            checkStateArray[54] = checkBox_54;
            checkStateArray[55] = checkBox_55; 
            checkStateArray[56] = checkBox_56;
            checkStateArray[57] = checkBox_57;
            checkStateArray[58] = checkBox_58;
            checkStateArray[59] = checkBox_59;
            checkStateArray[60] = checkBox_60;
            checkStateArray[61] = checkBox_61;
            checkStateArray[62] = checkBox_62;
            checkStateArray[63] = checkBox_63;
            checkStateArray[64] = checkBox_64;
            checkStateArray[65] = checkBox_65;
            checkStateArray[66] = checkBox_66;
            checkStateArray[67] = checkBox_67;
            checkStateArray[68] = checkBox_68;
            checkStateArray[69] = checkBox_69;
            checkStateArray[70] = checkBox_70;
            checkStateArray[71] = checkBox_71;



            // Initialize default values:
            //DeviceIndex = AIOUSB.diFirst;   // Default to first device found 
            DeviceIndex = AIOUSB.diOnly;   // Default to first device found 

            UInt32 Status;

            // Initit Power On states:
            OutMask[0] = 0x00;
            OutMask[0] = 0x00;

            for (i = 0; i < numPorts; i++)  
            {
                Data[i] = 0x00;  // DO Fets de energized
                bModeOut[i] = false; // DIO Input mode
            }

            // Config
            Status = AIOUSB.DIO_Configure(DeviceIndex, bTristateAll, OutMask, Data);

            AIOUSB.DIO_ReadAll(DeviceIndex, Data); // we just set this validate
        }
        
        private void Form1_Load(object sender, EventArgs e)
        {
            // Called before Form is displayed Initialize resources:

            // Query Device Info:
            UInt32 Status;
            UInt32 PID = 0;
            UInt32 NameSize = 256; // must pass this in by reference it gets used as sizeof buffer in and then modified as sizeof buffer out 
            string strName = "name";  // May need string builder for this
            UInt32 DIOBytes = 0;
            UInt32 Counters = 0;
            UInt64 SerNum;

            UInt32 ERROR_SUCCESS = 0;
            bool deviceIndexValid = false;

            // Get The Device Information test for valid device found:
            Status = AIOUSB.QueryDeviceInfo(DeviceIndex, out PID, out NameSize, out strName, out DIOBytes, out Counters);
            if ((Status == ERROR_SUCCESS) && (((PID == 0x803C) || (PID == 0x803D) || (PID == 0x803E))))  // DIO48DO24 or DIO24DO12 or USBDO24
            {
                deviceIndexValid = true;
            }
            else
            {
                // If Only device is not valid then Launch connect device dialog box:
                // New parent aware subform:
                FormDetect DetectSubForm = new FormDetect(this);
                DetectSubForm.ShowDialog();

                Status = AIOUSB.QueryDeviceInfo(DeviceIndex, out PID, out NameSize, out strName, out DIOBytes, out Counters);
                if ((Status == ERROR_SUCCESS) && (PID >= 0x8018) && (PID <= 0x801E))
                    deviceIndexValid = true;
            }

            if (!deviceIndexValid)
            {
                // No valid device found should exit
                // this.Close();
            }

            // Add the event and the event handler for the method that will 
            // process the timer event to the timer:
            myTimer.Tick += new EventHandler(TimerEventProcessor);

            // Set the timer interval in miliseconds and start 55ms min resolution:
            myTimer.Interval = 100;
            myTimer.Start();

            // Check device status:

            Status = AIOUSB.ClearDevices();  // Cleans up any orphaned indexes
            Status = AIOUSB.GetDevices();
            Status = AIOUSB.GetDeviceSerialNumber(DeviceIndex, out SerNum);

            // Get The Device Information:
            Status = AIOUSB.QueryDeviceInfo(DeviceIndex, out PID, out NameSize, out strName, out DIOBytes, out Counters);
        }
        
        private void TimerEventProcessor(Object myObject, EventArgs myEventArgs)
        {
            // This is the method that runs when the timer event is raised:
            myTimer.Stop();

            UpdateGUIState();

            myTimer.Enabled = true;
        }
        
        private void UpdateGUIState()
        {            
            // Get data from board update display states:
            AIOUSB.DIO_ReadAll(DeviceIndex, Data);

            // Test each bit and set check state:
            for (int i = 0; i < numPins; i++)
            {
                if( (Data[i/8] & ( 1 << (i % 8) )) != 0 ) // looks complicated but efficient
                    checkStateArray[i].Checked = true; // High Level
                else
                    checkStateArray[i].Checked = false; // Low Level
            }
            
            // Update Txt All Hex and Binary:
            string myString;
            char pad = '0';
            txtReadAllHex.Text = "";
            txtReadAllBin.Text = "";
            for (int i = 0; i <= 8; i++)
            {
                txtReadAllHex.Text += " " + Data[i].ToString("X2");
                myString = Convert.ToString(Data[i], 2);
                txtReadAllBin.Text += " " + myString.PadLeft(8, pad);
            }
        }
 
        private void btnTristateAll_Click(object sender, EventArgs e)
        {
            // Need to stop the timer change board and GUI:
            myTimer.Stop(); 
            
            int i = 0;            
            Int32 iOutMask = 0x0000;
            Int16 isOutMask = 0x0000;

            //Get button sender Tag (index)
            Button btnSender = sender as Button;
            UInt32 iTagindex = Convert.ToUInt32(btnSender.Tag);
            
            // Toggle tristate var;
            if (bTristateAll != 0) // bool byte
            {
                bTristateAll = 0;
                btnSender.Text = "Enter Tristate Mode";
                Tristatelabel.Text = "Not Tristate: I/O Buffers Enabled";
            }
            else
            {
                bTristateAll = 1;
                btnSender.Text = " Exit Tristate Mode";
                Tristatelabel.Text = "Tristate Mode: I/O Buffers Disabled";
            }
            
            // Toggle board states:
            for (i = 0; i < numPorts; i++)
            {
                if (bModeOut[i] == true)  // if output mode
                {
                    // its 2 bytes one Int16 or short  
                    iOutMask = iOutMask | (1 << i); // Int32
                    isOutMask = (Int16)iOutMask;  //safe downcast?
                }
            }
            AIOUSB.DIO_Configure(DeviceIndex, bTristateAll, ref isOutMask, Data);

            // Restart timer thread:
            myTimer.Enabled = true;
        }

        private void btnToggle_Click(object sender, EventArgs e)
        {
            // Button Clicks to toggle the input output mode and display states:

            // Need to stop the timer change board and GUI:
            myTimer.Stop(); 
            
            Int32 i;
            Int32 iOutMask = 0x0000;
            Int16 isOutMask = 0x0000;

            // Note: only called by buttons 3-8

            //Get button sender Tag (index) 
            UInt32 iTagindex = 0;
            Button btnSender = sender as Button;
            if (btnSender != null)
            {
                iTagindex = Convert.ToUInt32(btnSender.Tag);
            }

            // Toggle local mode value and button display states:
            if (bModeOut[iTagindex])
            {
                bModeOut[iTagindex] = false;
                btnSender.Text = "Toggle to Output Mode";
            }
            else
            {
                bModeOut[iTagindex] = true;
                btnSender.Text = "Toggle to Input Mode";
            }

            // Toggle board states:            
            for (i = 0; i < 6; i++)  //  Shifted for  just 6 DIO ports
            {
                if (bModeOut[i] == true)
                {
                    // USB-DIO96 its 12 bits in one Int16 or short  
                    iOutMask = iOutMask | (1 << i); // Int32
                    isOutMask = (Int16)iOutMask;  //safe downcast
                }
            }

            i = (int)iTagindex;
            Data[i] = 0xFF; //Set new output byte high, in case user made a mistake
            AIOUSB.DIO_Configure(DeviceIndex, bTristateAll, ref isOutMask, Data);

            // Restart timer thread:
            myTimer.Enabled = true;
        }
        
        private void checkBoxPin_Click(object sender, EventArgs e)
        {
            // Need to stop the timer change board and GUI:
            myTimer.Stop();

            bool bHighLow;
            UInt32 iTagindex = 0;

            // get correct checkbox get the checked state

            //Get sender Tag (index) and if check
            CheckBox chkSender = sender as CheckBox;
            if (chkSender != null)
            {
                iTagindex = Convert.ToUInt32(chkSender.Tag);
            }
            bHighLow = chkSender.Checked;

            Int32 i;
            Int32 iOutMask = 0x0000;
            byte bByte = 1;

            i = (Int32)iTagindex;  // downcast

            iOutMask = ((Data[i / 8]) & (1 << (i % 8))); // get single bit
            if (iOutMask != 0)
                bByte = 0;

            AIOUSB.DIO_Write1(DeviceIndex, (UInt32)i, bByte);  // byte used like a bool

            // restart timer and Gui will update:
            myTimer.Enabled = true;
        }

        private void btnDevice_Click(object sender, EventArgs e)
        {
            // Launch connect device dialog box
            // Switch between multiple devices or reconnect

            // New parent aware subform:
            FormDetect DetectSubForm = new FormDetect(this);
            DetectSubForm.ShowDialog();
        }



    }
}
